## bart 0.4.04

=== Makefile ===
# Copyright 2013-2015. The Regents of the University of California.
# Copyright 2015-2018. Martin Uecker <martin.uecker@med.uni-goettingen.de>
# All rights reserved. Use of this source code is governed by
# a BSD-style license which can be found in the LICENSE file.

# we have a two stage Makefile
MAKESTAGE ?= 1

# silent make
#MAKEFLAGS += --silent

# clear out all implicit rules and variables
MAKEFLAGS += -R

# use for parallel make
AR=./ar_lock.sh

MKL?=0
CUDA?=0
ACML?=0
OMP?=1
SLINK?=0
DEBUG?=0
FFTWTHREADS?=1
ISMRMRD?=0

LOG_BACKEND?=0
LOG_SIEMENS_BACKEND?=0
LOG_ORCHESTRA_BACKEND?=0
LOG_GADGETRON_BACKEND?=0
ENABLE_MEM_CFL?=0
MEMONLY_CFL?=0


DESTDIR ?= /
PREFIX ?= usr/local/

BUILDTYPE = Linux
UNAME = $(shell uname -s)
NNAME = $(shell uname -n)

MYLINK=ln

ifeq ($(UNAME),Darwin)
	BUILDTYPE = MacOSX
	MYLINK = ln -s
endif

ifeq ($(BUILDTYPE), MacOSX)
	MACPORTS ?= 1
endif


ifeq ($(BUILDTYPE), Linux)
	# as the defaults changed on most Linux distributions
	# explicitly specify non-deterministic archives to not break make
	ARFLAGS ?= rsU
else
	ARFLAGS ?= rs
endif


ifeq ($(UNAME),Cygwin)
	BUILDTYPE = Cygwin
	NOLAPACKE ?= 1
endif

ifeq ($(UNAME),CYGWIN_NT-10.0)
	BUILDTYPE = Cygwin
	NOLAPACKE ?= 1
endif




# Paths

here  = $(realpath $(dir $(lastword $(MAKEFILE_LIST))))
root := $(here)

srcdir = $(root)/src
libdir = $(root)/lib
bindir = $(root)/bin

export TOOLBOX_PATH=$(root)


# Automatic dependency generation

DEPFILE = $(*D)/.$(*F).d
DEPFLAG = -MMD -MF $(DEPFILE)
ALLDEPS = $(shell find $(srcdir) utests -name ".*.d")


# Compilation flags

OPT = -O3 -ffast-math
CPPFLAGS ?= -Wall -Wextra
CFLAGS ?= $(OPT) -Wmissing-prototypes
CXXFLAGS ?= $(OPT)

ifeq ($(BUILDTYPE), MacOSX)
	CC ?= gcc-mp-6
else
	CC ?= gcc
	# for symbols in backtraces
	LDFLAGS += -rdynamic
endif




# openblas

ifneq ($(BUILDTYPE), MacOSX)
BLAS_BASE ?= /usr/
else
ifeq ($(MACPORTS),1)
BLAS_BASE ?= /opt/local/
CPPFLAGS += -DUSE_MACPORTS
endif
BLAS_BASE ?= /usr/local/opt/openblas/
endif

# cuda

CUDA_BASE ?= /usr/local/


# acml

ACML_BASE ?= /usr/local/acml/acml4.4.0/gfortran64_mp/

# mkl
MKL_BASE ?= /opt/intel/mkl/lib/intel64/ 

# fftw

ifneq ($(BUILDTYPE), MacOSX)
FFTW_BASE ?= /usr/
else
FFTW_BASE ?= /opt/local/
endif


# Matlab

MATLAB_BASE ?= /usr/local/matlab/

# ISMRM

ISMRM_BASE ?= /usr/local/ismrmrd/



# Main build targets are defined in build_targets.mk so that both CMake and Make can use the same definitions
# set values for TBASE TFLP TNUM TRECO TCALIB TMRI TSIM TIO in build_targets.mk
include build_targets.mk



MODULES = -lnum -lmisc -lnum -lmisc

MODULES_pics = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
MODULES_sqpics = -lsense -liter -llinops -lwavelet -llowrank -lnoncart
MODULES_pocsense = -lsense -liter -llinops -lwavelet
MODULES_nlinv = -lnoir -liter -lnlops -llinops
MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
MODULES_itsense = -liter -llinops
MODULES_ecalib = -lcalib
MODULES_ecaltwo = -lcalib
MODULES_caldir = -lcalib
MODULES_walsh = -lcalib
MODULES_calmat = -lcalib
MODULES_cc = -lcalib
MODULES_ccapply = -lcalib
MODULES_estvar = -lcalib
MODULES_nufft = -lnoncart -liter -llinops
MODULES_rof = -liter -llinops
MODULES_bench = -lwavelet -llinops
MODULES_phantom = -lsimu
MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet -lnlops
MODULES_sake = -lsake
MODULES_wave = -liter -lwavelet -llinops -lsense
MODULES_threshold = -llowrank -liter -ldfwavelet -llinops -lwavelet
MODULES_fakeksp = -lsense -llinops
MODULES_lrmatrix = -llowrank -liter -llinops
MODULES_estdims = -lnoncart -llinops
MODULES_ismrmrd = -lismrm
MODULES_wavelet = -llinops -lwavelet
MODULES_wshfl = -llinops -lwavelet -liter -llowrank -llinops


MAKEFILES = $(root)/Makefiles/Makefile.*

-include Makefile.$(NNAME)
-include Makefile.local
-include $(MAKEFILES)


# clang

ifeq ($(findstring clang,$(CC)),clang)
	CFLAGS += -fblocks
	LDFLAGS += -lBlocksRuntime
endif


CXX ?= g++
LINKER ?= $(CC)



ifeq ($(ISMRMRD),1)
TMRI += ismrmrd
MODULES_bart += -lismrm
endif

ifeq ($(NOLAPACKE),1)
CPPFLAGS += -DNOLAPACKE
MODULES += -llapacke
endif



XTARGETS += $(TBASE) $(TFLP) $(TNUM) $(TIO) $(TRECO) $(TCALIB) $(TMRI) $(TSIM)
TARGETS = bart $(XTARGETS)



ifeq ($(DEBUG),1)
CPPFLAGS += -g
CFLAGS += -g
endif


ifeq ($(PARALLEL),1)
MAKEFLAGS += -j
endif


ifeq ($(MAKESTAGE),1)
.PHONY: doc/commands.txt $(TARGETS)
default all clean allclean distclean doc/commands.txt doxygen test utest gputest $(TARGETS):
	make MAKESTAGE=2 $(MAKECMDGOALS)
else


CPPFLAGS += $(DEPFLAG) -iquote $(srcdir)/
CFLAGS += -std=gnu11
CXXFLAGS += -std=c++11




default: bart doc/commands.txt .gitignore


-include $(ALLDEPS)




# cuda

NVCC = $(CUDA_BASE)/bin/nvcc


ifeq ($(CUDA),1)
CUDA_H := -I$(CUDA_BASE)/include
CPPFLAGS += -DUSE_CUDA $(CUDA_H)
ifeq ($(BUILDTYPE), MacOSX)
CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -m64 -lstdc++
else
CUDA_L := -L$(CUDA_BASE)/lib64 -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib64
endif 
else
CUDA_H :=
CUDA_L :=  
endif

# sm_20 no longer supported in CUDA 9
GPUARCH_FLAGS ?= 
NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 $(GPUARCH_FLAGS) -I$(srcdir)/ -m64 -ccbin $(CC)
#NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -fopenmp -O3  -I$(srcdir)/


%.o: %.cu
	$(NVCC) $(NVCCFLAGS) -c $^ -o $@
	$(NVCC) $(NVCCFLAGS) -M $^ -o $(DEPFILE)


# OpenMP

ifeq ($(OMP),1)
CFLAGS += -fopenmp
CXXFLAGS += -fopenmp
else
CFLAGS += -Wno-unknown-pragmas
CXXFLAGS += -Wno-unknown-pragmas
endif



# BLAS/LAPACK

ifeq ($(ACML),1)
BLAS_H := -I$(ACML_BASE)/include
BLAS_L := -L$(ACML_BASE)/lib -lgfortran -lacml_mp -Wl,-rpath $(ACML_BASE)/lib
CPPFLAGS += -DUSE_ACML
else
BLAS_H := -I$(BLAS_BASE)/include
ifeq ($(BUILDTYPE), MacOSX)
BLAS_L := -L$(BLAS_BASE)/lib -lopenblas
else
ifeq ($(NOLAPACKE),1)
BLAS_L := -L$(BLAS_BASE)/lib -llapack -lblas
CPPFLAGS += -Isrc/lapacke
else
BLAS_L := -L$(BLAS_BASE)/lib -llapacke -lblas
endif
endif
endif

ifeq ($(MKL),1)
BLAS_H := -I$(MKL_BASE)/include
BLAS_L := -L$(MKL_BASE)/lib/intel64 -lmkl_intel_lp64 -lmkl_gnu_thread -lmkl_core
CPPFLAGS += -DUSE_MKL -DMKL_Complex8="complex float" -DMKL_Complex16="complex double"
CFLAGS += -DUSE_MKL -DMKL_Complex8="complex float" -DMKL_Complex16="complex double"
endif



CPPFLAGS += $(FFTW_H) $(BLAS_H)



# png
PNG_L := -lpng

ifeq ($(SLINK),1)
	PNG_L += -lz
endif

ifeq ($(LINKER),icc)
	PNG_L += -lz
endif



# fftw

FFTW_H := -I$(FFTW_BASE)/include/
FFTW_L := -L$(FFTW_BASE)/lib -lfftw3f

ifeq ($(FFTWTHREADS),1)
	FFTW_L += -lfftw3f_threads
	CPPFLAGS += -DFFTWTHREADS
endif

# Matlab

MATLAB_H := -I$(MATLAB_BASE)/extern/include
MATLAB_L := -Wl,-rpath $(MATLAB_BASE)/bin/glnxa64 -L$(MATLAB_BASE)/bin/glnxa64 -lmat -lmx -lm -lstdc++

# ISMRM

ifeq ($(ISMRMRD),1)
ISMRM_H := -I$(ISMRM_BASE)/include
ISMRM_L := -L$(ISMRM_BASE)/lib -lismrmrd
else
ISMRM_H :=
ISMRM_L :=
endif

# Enable in-memory CFL files

ifeq ($(ENABLE_MEM_CFL),1)
CPPFLAGS += -DUSE_MEM_CFL
miscextracxxsrcs += $(srcdir)/misc/mmiocc.cc
LDFLAGS += -lstdc++
endif

# Only allow in-memory CFL files (ie. disable support for all other files)

ifeq ($(MEMONLY_CFL),1)
CPPFLAGS += -DMEMONLY_CFL
miscextracxxsrcs += $(srcdir)/misc/mmiocc.cc
LDFLAGS += -lstdc++
endif

# Logging backends

ifeq ($(LOG_BACKEND),1)
CPPFLAGS += -DUSE_LOG_BACKEND
ifeq ($(LOG_SIEMENS_BACKEND),1)
miscextracxxsrcs += $(srcdir)/misc/UTrace.cc
endif
ifeq ($(LOG_ORCHESTRA_BACKEND),1)
miscextracxxsrcs += $(srcdir)/misc/Orchestra.cc
endif
endif


# change for static linking

ifeq ($(SLINK),1)
# work around fortran problems with static linking
LDFLAGS += -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -Wl,--allow-multiple-definition
LIBS += -lmvec
BLAS_L += -llapack -lblas -lgfortran -lquadmath
endif



# Modules

.LIBPATTERNS := lib%.a


vpath %.a lib

DIRS = $(root)/rules/*.mk

include $(DIRS)

# sort BTARGETS after everything is included
BTARGETS:=$(sort $(BTARGETS))
XTARGETS:=$(sort $(XTARGETS))



.gitignore: .gitignore.main Makefile*
	@echo '# AUTOGENERATED. DO NOT EDIT. (are you looking for .gitignore.main ?)' > .gitignore
	cat .gitignore.main >> .gitignore
	@echo $(patsubst %, /%, $(TARGETS) $(UTARGETS)) | tr ' ' '\n' >> .gitignore


doc/commands.txt: bart
	./rules/update_commands.sh ./bart doc/commands.txt $(XTARGETS)

doxygen: makedoc.sh doxyconfig bart
	 ./makedoc.sh


all: .gitignore $(TARGETS)





# special targets


$(XTARGETS): CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h


bart: CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h


mat2cfl: $(srcdir)/mat2cfl.c -lnum -lmisc
	$(CC) $(CFLAGS) $(MATLAB_H) -omat2cfl  $+ $(MATLAB_L) $(CUDA_L)





# implicit rules

%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

%.o: %.cc
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

ifeq ($(PARALLEL),1)
(%): %
	$(AR) $(ARFLAGS) $@ $%
else
(%): %
	$(AR) $(ARFLAGS) $@ $%
	rm $%
endif


# we add the rm because intermediate files are not deleted
# automatically for some reason
# (but it produces errors for parallel builds for make all)



.SECONDEXPANSION:
$(TARGETS): % : src/main.c $(srcdir)/%.o $$(MODULES_%) $(MODULES)
	$(LINKER) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS) -Dmain_real=main_$@ -o $@ $+ $(FFTW_L) $(CUDA_L) $(BLAS_L) $(PNG_L) $(ISMRM_L) $(LIBS) -lm
#	rm $(srcdir)/$@.o

UTESTS=$(shell $(root)/utests/utests-collect.sh ./utests/$@.c)

.SECONDEXPANSION:
$(UTARGETS): % : utests/utest.c utests/%.o $$(MODULES_%) $(MODULES)
	$(CC) $(LDFLAGS) $(CFLAGS) $(CPPFLAGS) -DUTESTS="$(UTESTS)" -o $@ $+ $(FFTW_L) $(CUDA_L) $(BLAS_L) $(LIBS) -lm


# linker script version - does not work on MacOS X
#	$(CC) $(LDFLAGS) -Wl,-Tutests/utests.ld $(CFLAGS) -o $@ $+ $(FFTW_L) $(CUDA_L) $(BLAS_L) -lm

clean:
	rm -f `find $(srcdir) -name "*.o"`
	rm -f utests/*.o
	rm -f $(patsubst %, %, $(UTARGETS))
	rm -f $(root)/lib/.*.lock

allclean: clean
	rm -f $(libdir)/*.a $(ALLDEPS)
	rm -f $(patsubst %, %, $(TARGETS))
	rm -f $(srcdir)/misc/version.inc
	rm -rf doc/dx
	rm -f doc/commands.txt

distclean: allclean


# automatic tests

# system tests

TOOLDIR=$(root)
TESTS_TMP=$(root)/tests/tmp/$$$$/
TESTS_OUT=$(root)/tests/out/


include $(root)/tests/*.mk

test:	${TESTS}

gputest: ${TESTS_GPU}

pythontest: ${TESTS_PYTHON}

# unit tests

# define space to faciliate running executables
define \n


endef

utests-all: $(UTARGETS)
	$(patsubst %,$(\n)./%,$(UTARGETS))

utest: utests-all
	@echo ALL UNIT TESTS PASSED.


endif	# MAKESTAGE


install: bart $(root)/doc/commands.txt
	install -d $(DESTDIR)/$(PREFIX)/bin/
	install bart $(DESTDIR)/$(PREFIX)/bin/
	install -d $(DESTDIR)/$(PREFIX)/share/doc/bart/
	install $(root)/doc/*.txt $(root)/README $(DESTDIR)/$(PREFIX)/share/doc/bart/
	install -d $(DESTDIR)/$(PREFIX)/lib/bart/commands/


# generate release tar balls (identical to github)
%.tar.gz:
	git archive --prefix=bart-$(patsubst bart-%.tar.gz,%,$@)/ -o $@ v$(patsubst bart-%.tar.gz,%,$@)



# symbol table
bart.syms: bart
	rules/make_symbol_table.sh bart bart.syms

=== debian/changelog ===
bart (0.4.04-2) unstable; urgency=medium

  * Add some fixes from upstream.
  * Deactivate unit tests for ODE solver.
  * Deactivate unit tests for some archs.
  * Add autopkgtest for octave interface script.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Tue, 11 Dec 2018 13:07:12 +0100

bart (0.4.04-1) unstable; urgency=medium

  * New upstream version.
  * Relax error bound for new unit test.
  * Standards-Version: 4.2.1

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Mon, 10 Dec 2018 14:32:26 +0100

=== debian/control ===
Source: bart
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               libfftw3-dev,
               liblapack-dev | liblapack.so,
               libpng-dev,
               liblapacke-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/bart
Vcs-Git: https://salsa.debian.org/med-team/bart.git
Homepage: https://mrirecon.github.io/bart/

Package: bart
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: octave-bart
Description: tools for computational magnetic resonance imaging
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging. It consists of a programming library and a toolbox
 of command-line programs. The library provides common operations on
 multi-dimensional arrays, Fourier and wavelet transforms, as well as
 generic implementations of iterative optimization algorithms. The
 command-line tools provide direct access to basic operations on
 multi-dimensional arrays as well as efficient implementations of
 many calibration and reconstruction algorithms for parallel imaging
 and compressed sensing.

Package: libbart-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: Development files for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides headers and static libraries.

Package: octave-bart
Architecture: all
Depends: bart,
         ${misc:Depends}
Recommends: octave
Description: Octave bindings for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides Octave bindings for BART.

=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart

Tests: octave-integration
Depends: octave-bart, octave

## bart 0.5.00

=== CMakeLists.txt ===
# Copyright 2015-2016. Hans J. Johnson <hans-johnson@uiowa.edu>
# Copyright 2017-2018. Damien Nguyen <damien.nguyen@alumni.epfl.ch>
# All rights reserved. Use of this source code is governed by
# a BSD-style license which can be found in the LICENSE file.
# \author Hans J. Johnson <hans-johnson@uiowa.edu>
# \author Damien Nguyen <damien.nguyen@alumni.epfl.ch>
cmake_minimum_required(VERSION 2.8.12)

if(CMAKE_VERSION VERSION_GREATER 3.0)
  set(_policy_list CMP0012 CMP0028 CMP0042 CMP0048 CMP0051 CMP0054 CMP0057 CMP0074)
  foreach(_policy ${_policy_list})
    if(POLICY ${_policy})
      cmake_policy(SET ${_policy} NEW)
    endif()
  endforeach()
  # CMP0012: if() recognizes numbers and booleans
  # CMP0028: :: in target names
  # CMP0042: MACOS_RPATH
  # CMP0048: allow VERSION in project()
  # CMP0051: list TARGET_OBJECTS in SOURCES property
  # CMP0054: no more de-referencing of "expr" in if() statements
  # CMP0057: if IN_LIST
  # CMP0074: XXX_ROOT variables for find_package(XXX)
endif()
if(CMAKE_VERSION VERSION_LESS 3.10) # 3.10 instead of 3.3 due to CUDA support
  if(CMAKE_VERSION VERSION_GREATER 3.8.99)
    message(STATUS "From the BART maintainers: ignore the message below")
  endif()
  cmake_policy(SET CMP0023 OLD) # target_link_libraries mixed signatures
else()
  cmake_policy(SET CMP0023 NEW) # target_link_libraries mixed signatures
endif()

# ==============================================================================
# Internal helper variables

set(_compile_flags_c)
set(_compile_flags_cxx)
set(_compile_flags_c_release)
set(_compile_flags_cxx_release)

# ==============================================================================
# Macro definitions

include(${CMAKE_CURRENT_LIST_DIR}/cmake/bart_macros.cmake)

# ==============================================================================
# Get the version now, so that we can set it when creating the project

if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/.git)
  find_package(Git QUIET)
  if(Git_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} describe --match "v*" --dirty
      OUTPUT_VARIABLE _full_version
      RESULT_VARIABLE _ret
      WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})

    if(_ret EQUAL 0)
      string(STRIP ${_full_version} _full_version)
      # _full_version is of the form: v0.4.03-109-gf9c0f56-dirty
      string(REGEX MATCHALL "[0-9]+" _version_list ${_full_version})
      list(GET _version_list 0 _version_major)
      list(GET _version_list 1 _version_minor)
      list(GET _version_list 2 _version_patch)
      file(WRITE ${CMAKE_CURRENT_LIST_DIR}/version.txt
	"v${_version_major}.${_version_minor}.${_version_patch}\n")
    else()
      get_version_from_file(${CMAKE_CURRENT_LIST_DIR}/version.txt)
    endif()
    
  else()
    get_version_from_file(${CMAKE_CURRENT_LIST_DIR}/version.txt)
  endif()
else()
  get_version_from_file(${CMAKE_CURRENT_LIST_DIR}/version.txt)
endif()

# ==============================================================================
# Create the BART project

if(CMAKE_VERSION VERSION_LESS 3.0)
  project(BART C)
  set(PROJECT_VERSION_MAJOR ${_version_major})
  set(PROJECT_VERSION_MINOR ${_version_minor})
  set(PROJECT_VERSION_PATCH ${_version_patch})
  set(${CMAKE_PROJECT_NAME}_VERSION_MAJOR ${_version_major})
  set(${CMAKE_PROJECT_NAME}_VERSION_MINOR ${_version_minor})
  set(${CMAKE_PROJECT_NAME}_VERSION_PATCH ${_version_patch})
else()
  project(BART
    LANGUAGES C
    VERSION "${_version_major}.${_version_minor}.${_version_patch}")
endif()

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE
    PROPERTY
    STRINGS "Debug" "Release" "RelWithDebInfo")
endif()

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_LIST_DIR}/cmake)

#==============================================================================
# Options

# NB: must be before compiler flags since we might enable CXX or CUDA
include(${CMAKE_CURRENT_LIST_DIR}/cmake/bart_options.cmake)

#==============================================================================
# Setup compiler flags

# http://stackoverflow.com/questions/24840030/forcing-c99-in-cmake-to-use-for-loop-initial-declaration
if (CMAKE_VERSION VERSION_LESS 3.1)
  if (CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
      CMAKE_C_COMPILER_ID STREQUAL "Clang")
    set (CMAKE_C_FLAGS "--std=gnu11 ${CMAKE_C_FLAGS}")
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
      CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set (CMAKE_CXX_FLAGS "--std=c++14 ${CMAKE_CXX_FLAGS}")
  endif()
else()
  set(CMAKE_C_STANDARD 11)
  set(CMAKE_C_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

# ==============================================================================

# --- Provide good defaults for searching for packages (i.e. ismrmrd)
if(NOT CMAKE_PREFIX_PATH)
  list(APPEND CMAKE_PREFIX_PATH "/usr/local")
endif()
if(EXISTS $ENV{CMAKE_PREFIX_PATH})
  list(APPEND CMAKE_PREFIX_PATH $ENV{CMAKE_PREFIX_PATH})
endif()
if(EXISTS $ENV{ISMRMRD_HOME})
  list(APPEND CMAKE_PREFIX_PATH $ENV{ISMRMRD_HOME})
endif()
if(CMAKE_PREFIX_PATH)
  list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endif()

# --- Mac specific setup options
if(APPLE)
  # Look for MacPorts only as Homebrew users do not require any particular setup
  find_program(MACPORTS
    NAMES port
    PATHS /opt/local/bin /opt/local/sbin)
  if(MACPORTS)
    add_definitions(-DUSE_MACPORTS)
  endif()
endif()

# ==============================================================================
# Set compiler flags

check_for_compiler_flags(_compile_flags_release
  "-ffast-math /fp:fast -fast"
  "-O3 /Ox"
  )

if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang"
    OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  list(APPEND _compile_flags_c "-fblocks")
  list(APPEND _compile_flags_cxx "-fblocks")
endif()

if(CMAKE_VERSION VERSION_GREATER 3.2.99)
  add_compile_options(
    "$<$<COMPILE_LANGUAGE:C>:${_compile_flags_c}>"
    "$<$<AND:$<CONFIG:RELEASE>,$<COMPILE_LANGUAGE:C>>:${_compile_flags_release_c}>"
    )
  if(CMAKE_CXX_COMPILER_LOADED)
    add_compile_options(
    "$<$<COMPILE_LANGUAGE:CXX>:${_compile_flags_cxx}>"
    "$<$<AND:$<CONFIG:RELEASE>,$<COMPILE_LANGUAGE:CXX>>:${_compile_flags_release_cxx}>"
      )
  endif()
else()
  foreach(_flag ${_compile_flags_c})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_flag}")
  endforeach()
  foreach(_flag ${_compile_flags_c_release})
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${_flag}")
  endforeach()
  if(CMAKE_CXX_COMPILER_LOADED)
    foreach(_flag ${_compile_flags_cxx})
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_flag}")
    endforeach()
    foreach(_flag ${_compile_flags_cxx_release})
      set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${_flag}")
    endforeach()
  endif()
endif()

set(CMAKE_DEBUG_POSTFIX "d")
set(CMAKE_RELWITHDEBINFO_POSTFIX "rd")
set(CMAKE_MINSIZEREL_POSTFIX "rm")

# ==============================================================================
# Find a BLAS-capable library

include(${CMAKE_CURRENT_LIST_DIR}/cmake/BARTFindBLASlib.cmake)

##======================================================================

if(DEFINED _full_version)
  set(BART_FULL_VERSION_STRING ${_full_version})
else()
  set(BART_FULL_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
endif()
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/version.inc.in "VERSION(\@BART_FULL_VERSION_STRING\@)")
configure_file(${CMAKE_CURRENT_BINARY_DIR}/version.inc.in ${CMAKE_CURRENT_BINARY_DIR}/version.inc @ONLY)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

## ========== Process build_targets.mk
set (ALLPROGS "")
file(READ "${CMAKE_CURRENT_LIST_DIR}/build_targets.mk" bld_tgt_list_of_list)
# Convert file contents into a CMake list (where each element in the list
# is one line of the file)
#
string(REGEX REPLACE ";" "\\\\;" bld_tgt_list_of_list "${bld_tgt_list_of_list}")
string(REGEX REPLACE "\n" ";" bld_tgt_list_of_list "${bld_tgt_list_of_list}")
foreach(bld_tgt_line ${bld_tgt_list_of_list})
  if( "${bld_tgt_line}" MATCHES "^[^#].*=.*")
    string(REGEX REPLACE "^ *([^=]*) *= *(.*) *" "\\1" BLD_KEY "${bld_tgt_line}")
    string(REGEX REPLACE "^ *([^=]*) *= *(.*) *" "\\2" BLD_VALUE "${bld_tgt_line}")
    string(REPLACE " " ";" ${BLD_KEY} "${BLD_VALUE}")  ## Create a new variable called ${BLD_KEY}
    ## message(STATUS "KEY:${BLD_KEY}:    VALUE:${${BLD_KEY}}:")
    list(APPEND ALLPROGS ${${BLD_KEY}})
  endif()
endforeach()

if(DEFINED BART_EXTRA_PROGS)
  list(APPEND ALLPROGS ${BART_EXTRA_PROGS})
endif()

if(BART_ISMRMRD)
  list(APPEND ALLPROGS ismrmrd) 
endif()

if(BART_DISABLE_PNG)
  list(REMOVE_ITEM ALLPROGS "toimg")
endif()

list(SORT ALLPROGS)


set(BART_SUPPORT_LIBS)
file(GLOB support_libs ${CMAKE_CURRENT_LIST_DIR}/src/*)
foreach(_f ${support_libs})
  if(IS_DIRECTORY ${_f})
    get_filename_component(_name ${_f} NAME)
    if(NOT "${_name}" STREQUAL "python")
      list(APPEND BART_SUPPORT_LIBS ${_name})
    endif()
  endif()
endforeach()

if(BART_ISMRMRD)
  link_directories(${ISMRMRD_LIBRARY_DIRS})
  include_directories(${ISMRMRD_INCLUDE_DIRS})
else()
    list(REMOVE_ITEM BART_SUPPORT_LIBS ismrm)
endif()

if(NOT BART_NO_LAPACKE)
  list(REMOVE_ITEM BART_SUPPORT_LIBS lapacke)
endif()

include_directories(${CMAKE_CURRENT_LIST_DIR}/src)

set(bart_support_SRCS "")
set(bart_support_CCSRCS "")
set(bart_support_CUSRCS "")
foreach(curr_lib ${BART_SUPPORT_LIBS})
    file(GLOB ${curr_lib}_SRCS "src/${curr_lib}/*.c")
    list(APPEND bart_support_SRCS ${${curr_lib}_SRCS})
  
    file(GLOB ${curr_lib}_CCSRCS "src/${curr_lib}/*.cc")
    list(APPEND bart_support_SRCS ${${curr_lib}_CCSRCS})

    file(GLOB ${curr_lib}_CUSRCS "src/${curr_lib}/*.cu")
    list(APPEND bart_support_CUSRCS ${${curr_lib}_CUSRCS})
endforeach()

# ------------------------------------------------------------------------------
# These files need to be compiled separately since they might contain
# Python code

set(BARTSUPPORT_PYTHON_SEPARATE_COMPILATION_FILES
  "${CMAKE_CURRENT_LIST_DIR}/src/misc/mmiocc.cc"
  "${CMAKE_CURRENT_LIST_DIR}/src/misc/mmio.c"
  "${CMAKE_CURRENT_LIST_DIR}/src/misc/misc.c")
foreach(file ${BARTSUPPORT_PYTHON_SEPARATE_COMPILATION_FILES})
  list(REMOVE_ITEM bart_support_SRCS "${file}")
endforeach()

if(NOT BART_ENABLE_MEM_CFL)
  list(REMOVE_ITEM
    BARTSUPPORT_PYTHON_SEPARATE_COMPILATION_FILES
    "${CMAKE_CURRENT_LIST_DIR}/src/misc/mmiocc.cc")
endif()

# ------------------------------------------------------------------------------

if(BART_DISABLE_PNG)
  list(REMOVE_ITEM bart_support_SRCS "${CMAKE_CURRENT_LIST_DIR}/src/misc/png.c")
endif()

set(LOG_BACKEND_SRCS "")
list(REMOVE_ITEM bart_support_SRCS "${CMAKE_CURRENT_LIST_DIR}/src/misc/UTrace.cc")
list(REMOVE_ITEM bart_support_SRCS "${CMAKE_CURRENT_LIST_DIR}/src/misc/Orchestra.cc")

if(BART_LOG_BACKEND)
  set(DEBUG_C_FILE "${CMAKE_CURRENT_LIST_DIR}/src/misc/debug.c")
  set(LOG_BACKEND_SRCS "${DEBUG_C_FILE}")
  
  if(BART_LOG_SIEMENS_BACKEND)
    if(NOT EXISTS "${CMAKE_CURRENT_LIST_DIR}/src/misc/UTrace.cc")
      set(_ERR "Could not find the src/misc/UTrace.cc file\n")
      set(_ERR "${_ERR}You can download a copy of UTrace.cc at:\n")
      set(_ERR "${_ERR}https://www.mr-idea.com/communities/idea/Lists/Customer/UTrace.cc\n")
      message(FATAL_ERROR "${_ERR}")
    endif()
    # No need to add any include paths as the required code was copied into UTrace.cc from Siemens' IDEA framework
    list(APPEND LOG_BACKEND_SRCS "${CMAKE_CURRENT_LIST_DIR}/src/misc/UTrace.cc")
  endif()

  # ------------------------------------
  
  if(BART_LOG_ORCHESTRA_BACKEND)
    set(OX_INSTALL_DIRECTORY "" CACHE PATH "Install directory of the GE Orchestra SDK")
    set(TOPDIR "${OX_INSTALL_DIRECTORY}/include")

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright 2013-2015. The Regents of the University of California.
-# Copyright 2015-2018. Martin Uecker <martin.uecker@med.uni-goettingen.de>
+# Copyright 2015-2019. Martin Uecker <martin.uecker@med.uni-goettingen.de>
 # All rights reserved. Use of this source code is governed by
 # a BSD-style license which can be found in the LICENSE file.
 
@@ -8,6 +8,9 @@
 
 # silent make
 #MAKEFLAGS += --silent
+
+# auto clean on makefile updates
+AUTOCLEAN?=1
 
 # clear out all implicit rules and variables
 MAKEFLAGS += -R
@@ -23,6 +26,7 @@
 DEBUG?=0
 FFTWTHREADS?=1
 ISMRMRD?=0
+NOEXEC_STACK?=0
 
 LOG_BACKEND?=0
 LOG_SIEMENS_BACKEND?=0
@@ -165,6 +169,7 @@
 MODULES_sqpics = -lsense -liter -llinops -lwavelet -llowrank -lnoncart
 MODULES_pocsense = -lsense -liter -llinops -lwavelet
 MODULES_nlinv = -lnoir -liter -lnlops -llinops
+MODULES_moba = -lmoba -lnoir -liter -lnlops -llinops -lwavelet
 MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
 MODULES_itsense = -liter -llinops
 MODULES_ecalib = -lcalib
@@ -177,21 +182,24 @@
 MODULES_estvar = -lcalib
 MODULES_nufft = -lnoncart -liter -llinops
 MODULES_rof = -liter -llinops
+MODULES_tgv = -liter -llinops
 MODULES_bench = -lwavelet -llinops
 MODULES_phantom = -lsimu
-MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet -lnlops
+MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet -lnlops -lmoba
 MODULES_sake = -lsake
-MODULES_wave = -liter -lwavelet -llinops -lsense
+MODULES_traj = -lnoncart
+MODULES_wave = -liter -lwavelet -llinops -llowrank
 MODULES_threshold = -llowrank -liter -ldfwavelet -llinops -lwavelet
 MODULES_fakeksp = -lsense -llinops
 MODULES_lrmatrix = -llowrank -liter -llinops
 MODULES_estdims = -lnoncart -llinops
 MODULES_ismrmrd = -lismrm
 MODULES_wavelet = -llinops -lwavelet
-MODULES_wshfl = -llinops -lwavelet -liter -llowrank -llinops
-
-
-MAKEFILES = $(root)/Makefiles/Makefile.*
+MODULES_wshfl = -llinops -lwavelet -liter -llowrank
+
+
+MAKEFILES = $(wildcard $(root)/Makefiles/Makefile.*)
+ALLMAKEFILES = $(root)/Makefile $(wildcard $(root)/Makefile.* $(root)/*.mk $(root)/rules/*.mk $(root)/Makefiles/Makefile.*)
 
 -include Makefile.$(NNAME)
 -include Makefile.local
@@ -233,6 +241,9 @@
 CFLAGS += -g
 endif
 
+ifeq ($(NOEXEC_STACK),1)
+CPPFLAGS += -DNOEXEC_STACK
+endif
 
 ifeq ($(PARALLEL),1)
 MAKEFLAGS += -j
@@ -243,6 +254,12 @@
 .PHONY: doc/commands.txt $(TARGETS)
 default all clean allclean distclean doc/commands.txt doxygen test utest gputest $(TARGETS):
 	make MAKESTAGE=2 $(MAKECMDGOALS)
+
+tests/test-%: force
+	make MAKESTAGE=2 $(MAKECMDGOALS)
+
+force: ;
+
 else
 
 
@@ -506,18 +523,37 @@
 
 clean:
 	rm -f `find $(srcdir) -name "*.o"`
-	rm -f utests/*.o
+	rm -f $(root)/utests/*.o
 	rm -f $(patsubst %, %, $(UTARGETS))
-	rm -f $(root)/lib/.*.lock
+	rm -f $(libdir)/.*.lock
 
 allclean: clean
 	rm -f $(libdir)/*.a $(ALLDEPS)
 	rm -f $(patsubst %, %, $(TARGETS))
 	rm -f $(srcdir)/misc/version.inc
-	rm -rf doc/dx
-	rm -f doc/commands.txt
+	rm -rf $(root)/tests/tmp/*/
+	rm -rf $(root)/doc/dx
+	rm -f $(root)/doc/commands.txt
+	touch isclean
 
 distclean: allclean
+
+
+
+-include isclean
+
+
+isclean: $(ALLMAKEFILES)
+ifeq ($(AUTOCLEAN),1)
+	@echo "CONFIGURATION MODIFIED. RUNNING FULL REBUILD."
+	touch isclean
+	make allclean || rm isclean
+else
+ifneq ($(MAKECMDGOALS),allclean)
+	@echo "CONFIGURATION MODIFIED."
+endif
+endif
+
 
 
 # automatic tests

=== debian/changelog ===
bart (0.5.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Standards-Version: 4.4.0

  [ Andreas Tille ]
  * debhelper-compat 12
  * Remove trailing whitespace in debian/copyright

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Tue, 27 Aug 2019 14:18:12 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                libfftw3-dev,
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Some tests fail on the following architectures probably
# due to minor differences in floating point processing.
# For now, just turn it off...
NOTEST_ARCHS=armel armhf i386 mips mips64el mipsel hurd-i386 kfreebsd-i386 m68k powerpcspe sh4

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter $(NOTEST_ARCHS), $(DEB_BUILD_ARCH)))
	make utest
endif
